package meerkat.crypto.dkg.comm;

import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.Message;
import meerkat.protobuf.DKG;

/**
 * Created by Tzlil on 2/14/2016.
 * an interface for handling received messages
 */
public interface MessageHandler {

    /**
     * Handle a broadcast (or unicast) message.
     * If the message is invalid, the handler can throw an {@link InvalidProtocolBufferException}, in which
     * case the message will simply be ignored.
     * @param envelope
     */
    void handleMessage(DKG.BroadcastMessage envelope) throws InvalidProtocolBufferException;
//
//    /**
//     * handle share message
//     */
//    void handleShareMessage(int sender, boolean isBroadcast, Message message);
//
//    /**
//     * handle commitment message
//     */
//    void handleCommitmentMessage(int sender, boolean isBroadcast, Message message);
//
//    /**
//     * handle complaint message
//     */
//    void handleComplaintMessage(int sender, boolean isBroadcast, Message message);
//
//    /**
//     * handle done message
//     */
//    void handleDoneMessage(int sender, boolean isBroadcast, Message message);
//
//    /**
//     * handle answer message
//     */
//    void handleAnswerMessage(int sender, boolean isBroadcast, Message message);
//
//    /**
//     * handle abort message
//     */
//    void handleAbortMessage(int sender, boolean isBroadcast, Message message);
}
